--[[

̃t@CRampageAÏꕔłB

RampageAI̓t[\tgł; Free Software FoundationzGNUʌOp_񏑂̏̂ƂōĔzzщς邱Ƃł܂;
GNUCZXo[W2A܂(Ȃ̑I)2ȑÕo[WɂāB

RampageAÍALpłƂ]Ĕzz܂B
*ۏ؂Ȃ*; s̐A̖ړÎ߂̓K̈ÖٓIȕۏ؂ȂĂB 
̑̏ڍׂɊւẮAGNUʌOp_񏑂ĂB

RampageAIƋGNUʌOp_񏑂̃Rs[𓯎Ɏ󂯎ׂł;
łȂȂAȉ̏֏ȂB
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

----------------------------
-- Main Command Processor --
----------------------------

-- Default command processing
function AI_Command(command,shiftkey)
	-- Sequence item to be added
	local seq = nil

	-- Check for special-case commands
	if command[1] == FOLLOW_CMD then
		-- Pretend shift-key was down, so we don't
		-- reset anything
		shiftkey = true
	end

	-- Reset holding position
	HoldPosition = false

	-- Check if we're clearing the sequencer
	if not shiftkey and command[1] ~= SKILL_OBJECT_CMD then
		-- Clear our sequencer queue
		List.clear(AI_seq)

		-- Reset the target lock
		Target.Lock = false

		-- Stop any existing movement
		if GetV(V_MOTION,HomunID) == MOTION_MOVE then
			Move(HomunID,GetV(V_POSITION,HomunID))
		end
	end

	-- Decide what to do, based on the command
	if command[1] == MOVE_CMD then
		-- "alt+right click" on ground

		CMD_AdvMove(command,shiftkey)

	elseif command[1] == ATTACK_OBJECT_CMD then
		-- "alt+right click" on monster, twice

		CMD_AdvAttack(command,shiftkey)

	elseif command[1] == SKILL_OBJECT_CMD then
		-- Skill targetted on enemy

		CMD_SkillObj(command)

	elseif command[1] == FOLLOW_CMD then
		-- "Alt+T"

		-- Alternate modes
		if Mode == MODE_AGGRO then
			Mode = MODE_PASSIVE
			Log("Mode changed to: Passive")
		else
			Mode = MODE_AGGRO
			Log("Mode changed to: Aggressive")
		end

	else
		-- Unknown command

		local msg = string.format("Unknown GetMsg() command: %d(",
			command[1])

		local i
		for i=2,5 do
			if command[i] == nil then
				break
			end

			if i ~= 2 then
				msg = msg .. ", "
			end
			msg = string.format("%s%d",msg,command[i])
		end
		msg = msg .. ")"
		Log(msg)
	end
end

---------------------------------
-- Command Processor Functions --
---------------------------------

-- Function to determine if a move command was a special command
function CMD_AdvMove(cmd,shiftkey)
	-- Get the x,y coords
	local x,y = cmd[2],cmd[3]

	-- Loop through all the actors, making a list of those that are close enough
	local actors = Table.new()
	local i,actor,motion,dist
	for actor,i in pairs(ActorTargets) do
		-- Check that the actor isn't the homunculus
		if actor ~= HomunID then
			-- Check if we're using AMCs
			if EnableAMC then
				-- Check if the actor is close enough to
				-- be the target of an AMC
				if APBlocks(actor,x,y) < 2 then
					-- Add the actor to the list
					Table.insert(actors,actor)
				end
			else
				-- Check if the actor is dead
				if GetV(V_MOTION,actor) ~= MOTION_DEAD then
					-- Get the actor's distance
					dist = APDistance(actor,x,y)
				
					-- Check if the actor is a monster and its close enough
					if IsMonster(actor) == 1 and
						dist <= MoveIsAttackWhenDistance then
						
						-- Add the actor to the list
						Table.insert(actors,actor)
					end
				end
			end
		end
	end
	
	-- Set the actor to -1
	actor = -1
	
	-- Check if we're using AMCs
	if EnableAMC then
		-- Check if we have an AMC target
		if AMCTarget ~= -1 then
			-- Check if the target is in our actors
			if ActorIsInTable(AMCTarget,actors) then
				-- It is, so its our actor this time around
				actor = AMCTarget
			end
		end
	else
		-- Prioritize the table
		actors = MPrioritySieve(actors)
	end
	
	-- Check if we didn't find an actor yet
	if actor == -1 then
		-- Get the nearest actor
		actor = PTNearest(x,y,actors)
	end
	
	-- Check if there is no closest actor
	if actor == -1 then
		-- Its just a simple move command

		CMD_Move(cmd)		
		
		return
	end

	-- Get actor's x,y coords
	local ax,ay = GetV(V_POSITION,actor)
	
	-- Get the block distance
	local dist = AABlocks(ax,ay,x,y)

	-- Check what the move command should be
	if IsMonster(actor)==1 and not EnableAMC then
		-- Move command is an attack command
		
		-- Log it
		Log("Interpretting move (%d,%d) as attack monster #%d at (%d,%d).",
			x,y,actor,ax,ay)

		-- Issue the attack command
		CMD_Attack({ SEQ_ATTACK, actor })
	else
		-- Check if we should do the move command
		if AMC_Parse(actor,x-ax,y-ay) and not shiftkey then
			-- Move command should continue
			CMD_Move(cmd)
		end
	end
end

-- Simple move command
function CMD_Move(command)
	-- Queue a command to set HoldPosition
	List.pushright(AI_seq, { SEQ_SET_HOLD, true })

	-- Queue the move command
	List.pushright(AI_seq,command)
end

-- Attack command, with possible 
function CMD_AdvAttack(command,shiftkey)
	-- Check the target
	local target = command[2]
	
	-- Check if the target is the same as our AMCTarget
	if target == AMCTarget then
		-- Check if theres a sequence
		if AMCSequence ~= "" then
			-- Execute the sequence
			local ret = AMC_Execute(AMCTarget,AMCSequence)
			
			-- Clear the sequence, and reset the timer
			AMCSequence=""
			AMCLastTime=0
			
			-- Check if we should continue with the
			-- attack command
			if not ret or shiftkey then
				-- We shouldn't
				return
			end
		end
	end
	
	-- Set the AMCTarget
	AMCTarget = target
	
	-- Use the attack command
	CMD_Attack(command)
end

-- Attack command
function CMD_Attack(command)
	-- Queue a command to set the target
	List.pushright(AI_seq, { SEQ_SET_TARGET, command[2], true })

	-- Add the command to the sequencer queue
	List.pushright(AI_seq,command)
end

-- Skill command
function CMD_SkillObj(command)
	List.pushleft(AI_seq,command)
end

-- Skill command, which triggers attack command
function CMD_SkillObjAndAttack(command)
	-- Use the skill first
	List.pushleft(AI_seq,command)
	
	-- Attack after using the skill
	CMD_Attack( { SEQ_ATTACK, command[4] } )
end

--------------------------------
-- Advanced Movement Commands --
--------------------------------

-- Initialize AMCs
function AMC_Init()
	-- Check if Advanced Movement Commands should are disabled
	if not EnableAMC then
		-- They are disabled, so remove all the functions
		AMC_Init = NoReturn
		AMC_Check = NoReturn
		AMC_Parse = TrueReturn
		AMC_Execute = TrueReturn
		AMC_Reset = NoReturn
		CMD_AdvAttack = CMD_Attack
		return
	end
	
	-- Add an attack function
	AMC_AddCommand("19", function(target)
		CMD_Attack( { SEQ_ATTACK, target } )
		return false
	end)
	
	-- Add a mode-changing function
	AMC_AddParser("2", function(target,command)
		-- Change modes depending on the command
		if command == "4" then
			Mode = MODE_PASSIVE
			Log("Mode changed to: Passive")
		elseif command == "6" then
			Mode = MODE_AGGRO
			Log("Mode changed to: Aggressive")
		end
		
		-- Don't follow with the move command
		return false
	end)
end

-- Check when the last received command was
function AMC_Check()
	-- Check if we should be checking... XD
	if AMCLastTime == 0 then
		return
	end
	
	-- Get the current tick count
	local ticks = GetTick()
	
	-- Check if its time to clear
	if ticks >= AMCLastTime + AMCResetTime then
		-- Log it
		Log("AMC sequence timed out.")
		
		-- Clear everything
		AMC_Reset()
	end
end

function AMC_Parse(target,x,y)
	-- Determine the subcommand name, based on the x- and y-deltas
	local subcmd = 0
	if x==-1 and y==-1 then
		subcmd = 1
	elseif x==0 and y==-1 then
		subcmd = 2
	elseif x==1 and y==-1 then
		subcmd = 3
	elseif x==-1 and y==0 then
		subcmd = 4
	elseif x==0 and y==0 then
		subcmd = 5
	elseif x==1 and y==0 then
		subcmd = 6
	elseif x==-1 and y==1 then
		subcmd = 7
	elseif x==0 and y==1 then
		subcmd = 8
	elseif x==1 and y==1 then
		subcmd = 9
	else
		-- Invalid, but this should never happen
		
		-- Log it
		Log("Invalid AMC subcommand (%d,%d). Resetting AMC sequence.",x,y)
		
		-- Reset
		AMC_Reset()
		
		-- Continue with the move command
		return true
	end
	
	-- Set the last time
	AMCLastTime = GetTick()
	
	-- Check if we have a new target
	if target ~= AMCTarget then
		-- Log it
		Log("Setting AMC target as Actor #%d (previously #%d)",target,AMCTarget)
		
		-- Set the target
		AMCTarget = target
		
		-- Reset the sequence
		AMCSequence = ""
	end

	-- Check if its the special subcommand "5", to execute
	if subcmd == 5 then
		-- Execute the sequence
		local ret = AMC_Execute(AMCTarget,AMCSequence)
		
		-- Clear the sequence, and reset the timer
		AMCSequence=""
		AMCLastTime=0
		
		-- Do not continue with the move
		return ret
	end
	
	-- Otherwise concatenate the subcmd to the sequence
		-- (ensure they're not converted to numbers)
	AMCSequence = string.format("%s%d",AMCSequence,subcmd)
	
	-- Continue with move command
	return true
end

function AMC_Execute(target,command)
	-- Check if the command is empty
	if command == "" then
		-- Do nothing, but move to them
		return true
	end
	
	-- Loop through each of the full command executers
	local i,max = 1,Table.getn(AMCFullCommands)
	for i=1,max do
		-- Check if the executer is the one we need
		if command == AMCFullCommands[i][1] then
			-- It is
			
			-- Log it
			Log("Executing Advanced Movement Command: %s(%d)",
				command,target)
			
			-- Execute it
			local func = AMCFullCommands[i][2]
			return func(target)
		end
	end
	
	-- Loop through each of the sub parsers
	local i,max = 1,Table.getn(AMCSubParsers)
	for i=1,max do
		-- Get the subparser's beginning command
		local subcmd = AMCSubParsers[i][1]
		
		-- Check if its the right one
		if string.sub(command,1,string.len(subcmd)) == subcmd then
			-- Its a subparser
			
			-- Get the argument
			local arg = string.sub(command,string.len(subcmd)+1)
			
			-- Log it
			Log("Executing AMC sub-parser: %s(%d,%s)",
				subcmd,target,arg)
				
			-- Parse it
			local func = AMCSubParsers[i][2]
			return func(target,arg)
		end
	end
	
	-- Log an Unrecognized AMC command
	Log("Unrecognized Advanced Movement Command: %q.",command)
	return true
end

-- Function to reset the Advanced Movement Commands
function AMC_Reset()
	AMCLastTime = 0
	AMCSequence = ""
	AMCTarget = -1
end

-- Function to add a full command to the AMCs
function AMC_AddCommand(cmd,f)
	Table.insert(AMCFullCommands,{ cmd, f })
end

-- Function to add a subparser to the AMCs
function AMC_AddParser(cmd,f)
	Table.insert(AMCSubParsers,{ cmd, f })
end
