--[[

̃t@CRampageAÏꕔłB

RampageAI̓t[\tgł; Free Software FoundationzGNUʌOp_񏑂̏̂ƂōĔzzщς邱Ƃł܂;
GNUCZXo[W2A܂(Ȃ̑I)2ȑÕo[WɂāB

RampageAÍALpłƂ]Ĕzz܂B
*ۏ؂Ȃ*; s̐A̖ړÎ߂̓K̈ÖٓIȕۏ؂ȂĂB 
̑̏ڍׂɊւẮAGNUʌOp_񏑂ĂB

RampageAIƋGNUʌOp_񏑂̃Rs[𓯎Ɏ󂯎ׂł;
łȂȂAȉ̏֏ȂB
Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

--]]

------------------------
-- Distance Functions --
------------------------

-- Position->Position Pythagorean Distance
function PPDistance(x1,y1,x2,y2)
	return math.floor(math.sqrt( (x2-x1)^2 + (y2-y1)^2 ))
end

-- Actor->Position Pythagorean Distance
function APDistance(actor,x,y)
	local x2,y2 = GetV(V_POSITION,actor)

	if x2 ~= -1 then
		return PPDistance(x2,y2,x,y)
	end

	-- If there was an invalid actor, return a high number
	return SightRange * SightRange
end

-- Actor->Actor Pythagorean Distance
function AADistance(actor1,actor2)
	local x,y = GetV(V_POSITION,actor2)

	if x ~= -1 then
		return APDistance(actor1,x,y)
	end

	-- If there was an invalid actor, return a high number
	return SightRange * SightRange
end

-- Position->Position Block Distance
function PPBlocks(x1,y1,x2,y2)
	local xdist = math.abs(x2-x1)
	local ydist = math.abs(y2-y1)

	if xdist > ydist then
		return xdist
	else
		return ydist
	end
end

-- Actor->Position Block Distance
function APBlocks(actor,x,y)
	local x2,y2 = GetV(V_POSITION,actor)

	if x2 ~= -1 then
		return PPBlocks(x2,y2,x,y)
	end

	-- If there was an invalid actor, return a high number
	return SightRange * SightRange
end

-- Actor->Actor Block Distance
function AABlocks(actor1,actor2)
	local x,y = GetV(V_POSITION,actor2)

	if x ~= -1 then
		return APBlocks(actor1,x,y)
	end

	-- If there was an invalid actor, return a high number
	return SightRange * SightRange
end

-- Find actor nearest to a position from a table
function PTNearest(x,y,t)
	-- Check the size of the table
	if Table.getn(t) < 1 then
		return -1
	end

	-- Loop through the table
	local i,dist
	local nearest=APDistance(t[1],x,y)
	local index=1
	for i=2,t.n do
		-- Get the distance to the actor
		dist=APDistance(t[i],x,y)

		-- Check if its closer
		if dist < nearest then
			-- Set the new nearest actor
			nearest=dist
			index=i
		end
	end

	-- Return the nearest
	return t[index]
end

-- Find actor nearest to another from a table
function ATNearest(actor,t)
	-- Check the size of the table
	if Table.getn(t) < 1 then
		return -1
	end

	-- Get the actor's current position
	local x,y = GetV(V_POSITION,actor)

	-- Get the nearest from the table
	return PTNearest(x,y,t)
end

---------------------------
-- Sight-range Functions --
---------------------------

-- Check if a position is in sight-range of our owner
function IsInSight(x,y)
	if APBlocks(OwnerID,x,y) > SightRange then
		return false
	end

	return true
end

-- Check if an actor is in sight-range of our owner
function ActorIsInSight(actor)
	if AABlocks(actor,OwnerID) > SightRange then
		return false
	end

	return true
end

-------------------
-- Actor Support --
-------------------

-- Check if an actor is in a table
function ActorIsInTable(actor,t)
	-- Loop through the table
	local i,max = 1,Table.getn(t)
	for i=1,max do
		-- Check if its the actor
		if t[i] == actor then
			-- It is, return true
			return true
		end
	end
	
	-- Otherwise the actor isn't in the table
	return false
end

-- Identify various bits of information, such as all the attackers
-- of a specific actor, members of the party, etc
function GetActorInfo()
	-- Get all the actors on the screen
	local actors = GetActors()

	-- Clear our table of actor targets
	ActorTargets = { }

	-- Clear our table of party members
	--PartyMembers = { }

	-- Loop through each actor, gathering data
	local i,actor,target
	for i,actor in ipairs(actors) do
		-- Check if the current actor has anything targetting it
		if ActorTargets[actor] == nil then
			-- Nope

			-- Create a table for it
			ActorTargets[actor] = Table.new()
		end

		-- Get the current actor's target
		target = GetV(V_TARGET,actor)

		-- Check if the actor is targetting anything
		if target ~= 0 then
			-- Check if the target has a table yet
			if ActorTargets[target] == nil then
				-- Nope

				-- Create a table for it
				ActorTargets[target] = Table.new()
			end

			-- Add the actor as an attacker of the target
			Table.insert(ActorTargets[target],actor)
		end

		-- Should we gather party data too?
		--[[if DefendParty and actor ~= HomunID and actor ~= OwnerID then
			-- Check if the actor is a monster
			if IsMonster(actor) ~= 1 then
				-- Note: Homunculi show as nonmonsters in nonpvp zones

				-- See if we can check their health
				-- NOTE: This idea was based on false "information"
				--		found on the RagnaInfo forums.
				if GetV(V_HP,actor) ~= -1 then
					-- Log it
					Log("Identified party member: Actor #%d",actor)

					-- Add them to the reference table
					PartyMembers[actor] = true
				end
			end
		end
		--]]
	end
end

-- Determine valid enemies from those targetting a specific actor
function ActorEnemies(id,t)
	-- Our return value
	local enemies

	-- Check if we have an existing table
	if t ~= nil then
		-- Add to the table
		enemies = t
	else
		-- Create a new table
		enemies = Table.new()
	end

	-- Grab the list of actors targetting id
	local actors = ActorTargets[id]

	-- Check if there is a list of actor
	if actors ~= nil then
		-- Loop through each actor
		local i,actor,motion
		for i,actor in ipairs(actors) do
			-- Check their motion
			motion = GetV(V_MOTION,actor)

			-- Check if the actor is in sight and not dead
			if motion ~= MOTION_DEAD and ActorIsInSight(actor) then
				-- Check if the actor is a valid enemy
				if IsValidAttacker(actor) and MonsterAllowed(actor) then
					-- Add it to the list of enemies
					Table.insert(enemies,actor)
				end
			end
		end
	end

	return enemies
end

--------------------------
-- Actor Classification --
--------------------------

-- Identify party members (and their homunculi)
function IsPartyMember(actor)
	if PartyMembers[actor] ~= nil then
		return true
	end

	return false
end

-- Identify enemies in PVP
function IsValidAttacker(actor)
	-- Check if the actor is a monster
	if IsMonster(actor) ~= 1 then
--[[
	Note: PVP players show up as enemies unless they're
		in your party
--]]
		-- Not a valid enemy
		return false
	end

	-- Check if its a PVP zone
	if not PVPZone then
		return true
	end
	
	-- Check the action thats being used against us
	local motion = GetV(V_MOTION,actor)

	if motion == MOTION_ATTACK or motion == MOTION_ATTACK2 or
		motion == MOTION_CASTING or motion == MOTION_SKILL then
		-- They're probably attacking us

		-- And one last check of who they're targetting
		local target = GetV(V_TARGET,actor)
		if target == HomunID or target == OwnerID or
			IsPartyMember(target) then
			return true
		else
			return false
		end
	else
		-- Not attacking us
		return false
	end

	-- Otherwise return true
	return true
end

-----------------------------
-- Skill Support Functions --
-----------------------------

-- Add an attack skill to our lists
function AddAttackSkill(id,sptable)
	-- Get the range of the skill
	local range = GetV(V_SKILLATTACKRANGE,HomunID,id)
	
	-- Check if the range is our lowest one yet
	if range < HomunSkillRange then
		HomunSkillRange = range
	end

	-- Make sure the sptable is valid
	local i
	for i=5,1,-1 do
		-- If there is an empty space in the sp usage table...
		if sptable[i] == nil then
			-- Fill it with a large number
			sptable[i] = 100 * 100
		end
	end

	-- Create the object
	local obj = { }
	obj.id = id
	obj.sp = sptable
	obj.range = range

	-- Check the range
	if range <= (HomunRange+1) then
		-- Its a melee skill
		Table.insert(AttackSkills,obj)
	else
		-- Its a ranged skill
		Table.insert(RangedSkills,obj)
	end
end

-- Determine if a skill is allowed or not
function SkillAllowed(type)
	-- If our owner is sitting, we can't cast //anything//
	if GetV(V_MOTION,OwnerID) == MOTION_SIT then
		-- Nope, no can do :(
		return false
	end

	-- Check if we have enough SP
	if ActorSP(HomunID) < MinSP then
		-- Will use too much SP, so its not allowed
		return false
	end

	-- Check if we're passive
	if Mode == MODE_PASSIVE then
		-- Check if we're trying to use an attack skill
		if type == SKILL_TYPE_MELEE or type == SKILL_TYPE_RANGED then
			-- Only allow it if the user okays it
			if not PassiveSkills then
				-- User didn't want it happening
				return false
			end
		end
	end

	-- Check the type of skill
	if type == SKILL_TYPE_MELEE and MeleeSkills then
		-- Its allowed
		return true
	elseif type == SKILL_TYPE_RANGED and ChaseSkills then
		-- Its allowed
		return true
	elseif type == SKILL_TYPE_SUPPORT and SupportSkills then
		-- Its allowed
		return true
	elseif type == SKILL_TYPE_HEAL and HealSkills then
		-- Its allowed
		return true
	end

	-- Otherwise its not allowed
	return false
end

-------------------
-- HP/SP Support --
-------------------

-- Calculate the delta of our own and our owner's HPs
function CalculateHPDeltas()
	-- Get the current tick count
	local ticks = GetTick()

	-- Get our owner's HP value
	local hp = GetV(V_HP,OwnerID)

	-- Remove any HP values that are older than 1000 milliseconds
	local other
	repeat
		-- Grab the oldest HP value
		other = List.popright(OwnerHPTracking)

		-- Check the validity
		if other == nil then
			other = { ticks, hp }
		end
	until ticks - other[1] <= 1000

	-- Its new enough, push it back on
	List.pushright(OwnerHPTracking,other)

	-- Get the delta
	OwnerHPDelta.second = hp - other[2]

	-- Now grab the newest HP value
	other = OwnerHPTracking[OwnerHPTracking.first]

	-- Get the delta
	OwnerHPDelta.iteration = hp - other[2]

	-- Now add this into our log
	List.pushleft(OwnerHPTracking,{ ticks, hp })

	-- Begin doing the exact same for homunculus
	hp = GetV(V_HP,HomunID)

	-- Remove any HP values that are older than 1000 milliseconds
	repeat
		-- Grab the oldest HP value
		other = List.popright(HomunHPTracking)

		-- Check the validity
		if other == nil then
			other = { ticks, hp }
		end
	until ticks - other[1] <= 1000

	-- Its new enough, so put it back
	List.pushright(HomunHPTracking,other)

	-- Get the delta
	HomunHPDelta.second = hp - other[2]

	-- Now grab the newest HP value
	other = HomunHPTracking[HomunHPTracking.first]

	-- Get the delta
	HomunHPDelta.iteration = hp - other[2]

	-- Now add this into our hp log
	List.pushleft(HomunHPTracking,{ ticks, hp })
end

-- Determine the amount of HP remaining
function ActorHP(actor)
	-- Get the actor's HP amount
	return GetV(V_HP,actor)
end

-- Determine the percentage of SP remaining
function ActorHPPercent(actor)
	-- Get the actor's HP and max HP amounts
	local hp = GetV(V_HP,actor)
	local max = GetV(V_MAXHP,actor)

	-- Turn it into a percentage and return
	return math.floor( (hp/max) * 100 )
end

-- Determine the maximum amount of SP that is usable
function SPUsable(actor)
	-- Subtract our minimum SP amount
	return ActorSP(actor) - MinSP
end

-- Determine the maximum amount of SP that is usable, using percents
function SPUsablePercent(actor)
	-- Get the percent our SP is at
	local sp = ActorSPPercent(actor)

	-- Determine the difference
	sp = sp - MinSP

	-- Check if we have spare SP
	if sp > 0 then
		-- Unpercentize it
		return math.floor((sp * GetV(V_MAXSP,actor) / 100))
	end

	return 0
end

-- Determine the amount of SP remaining
function ActorSP(actor)
	-- Get the actor's SP amount
	return GetV(V_SP,actor)
end

-- Determine the percentage of SP remaining
function ActorSPPercent(actor)
	-- Get the actor's SP and max SP amounts
	local sp = GetV(V_SP,actor)
	local max = GetV(V_MAXSP,actor)

	-- Turn it into a percentage and return
	return math.floor( (sp/max) * 100 )
end

-------------------------
-- Debugging Functions --
-------------------------

-- Normal log-style
function Log(text,a,b,c,d,e,f,g,h,i)
	TraceAI(string.format(text,a,b,c,d,e,f,g,h,i))
end

-- Workaround for logs when TraceAI.txt is only 1 line
function LogWorkaround(text,a,b,c,d,e,f,g,h,i)
	-- Format the text
	local str = string.format(text,a,b,c,d,e,f,g,h,i)

	-- Put the text into the log
	List.pushright(Logs,str)

	-- See if we need to remove a line
	if List.size(Logs) > LogLines then
		List.popleft(Logs)
	end

	-- Gather all the lines into 1 string
	str = "\r\n"
	local i
	for i=Logs.first,Logs.last do
		str = str .. Logs[i] .. "\r\n"
	end

	-- Output via TraceAI
	TraceAI(str)
end

--------------------
-- Math Functions --
--------------------

-- Return the modulus remainder of a number
function Modulus(a,b)
	return a - b*math.floor(a/b)
end

---------------------------
-- Function Replacements --
---------------------------

function NoReturn()
end

function ZeroReturn()
	return 0
end

function NegativeReturn()
	return -1
end

function TrueReturn()
	return true
end

function FalseReturn()
	return false
end